--- old/usr/src/tools/smatch/src/smatch_param_used.c	Mon Aug  5 08:38:41 2019
+++ new/usr/src/tools/smatch/src/smatch_param_used.c	Mon Aug  5 08:38:41 2019
@@ -31,7 +31,7 @@
 
 	if (!option_info)
 		return;
-	if (__in_fake_assign)
+	if (__in_fake_assign || __in_fake_parameter_assign || __in_function_def)
 		return;
 
 	arg = get_param_num_from_sym(sym);
@@ -51,7 +51,7 @@
 
 	arg_nr = get_param_num_from_sym(sym);
 	if (arg_nr >= 0)
-		set_state(my_id, name, sym, &used);
+		set_state_stree(&used_stree, my_id, name, sym, &used);
 free:
 	free_string(name);
 }
@@ -69,7 +69,12 @@
 		name = get_param_name(tmp);
 		if (!name)
 			continue;
+		if (is_recursive_member(name))
+			continue;
 
+		if (is_ignored_kernel_data(name))
+			continue;
+
 		sql_insert_return_implies(PARAM_USED, arg, name, "");
 	} END_FOR_EACH_SM(tmp);
 
